web/apps/projet/urls.py
from django.urls import path

from .views import get_fichier_tache, projet_liste, projet, ajout_projet, \
    edit_projet, statut_projet, edit_type_projet, delete_type_projet, \
    manage_types_projet, ajout_tache, edit_tache, ajout_creneau, edit_creneau, \
    ajout_participant_projet, suppression_participant_projet, \
    ajout_participant_creneau, ajout_participant_tache, suppression_creneau, \
    suppression_participant_tache, suppression_tache, terminer_tache, \
    tache_details, projet_description, diffuser_tache, \
    suppression_participant_creneau, valider_projet

urlpatterns = [
    path('', projet_liste, name='projet_liste'),
    path('<int:id_projet>/', projet, name='projet'),
    path('<int:id_projet>/valider/', valider_projet, name='valider_projet'),

    path('ajout/', ajout_projet, name='ajout_projet'),
    path('<int:id_projet>/edit/',edit_projet, name='edit_projet'),
    path('statut/', statut_projet, name='statut_projet'),

    path('type/<int:id>/modification', edit_type_projet,
         name='modification_type_projet'),
    path('type/<int:id>/suppression', delete_type_projet,
         name='suppression_type_projet'),
    path('type', manage_types_projet, name='gestion_types_projet'),

    path('projet/<int:id_projet>/tache/ajout/', ajout_tache,
         name='ajout_tache'),
    path('tache/<int:id_tache>/edit/', edit_tache, name='edit_tache'),

    path('tache/<int:id_tache>/creneau/ajout/', ajout_creneau,
         name='ajout_creneau'),
    path('creneau/<int:id_creneau>/edit/', edit_creneau,
         name='edit_creneau'),

    path('participant/ajout', ajout_participant_projet,
         name='ajout_participant_projet'),
    path('participant/suppression', suppression_participant_projet,
         name='suppression_participant_projet'),

    path('participant/creneau/ajout', ajout_participant_creneau,
         name='ajout_participant_creneau'),
    path('participant/tache/ajout', ajout_participant_tache,
         name='ajout_participant_tache'),
    path('creneau/suppression', suppression_creneau,
         name='suppression_creneau'),
    path('participant/creneau/suppression',
         suppression_participant_creneau,
         name='suppression_participant_creneau'),
    path('participant/tache/suppression', suppression_participant_tache,
         name='suppression_participant_tache'),

    path('tache/suppression', suppression_tache,
         name='suppression_tache'),
    path('tache/terminer', terminer_tache, name='terminer_tache'),

    path('tache/', tache_details, name='tache_details'),
    path('description/', projet_description, name='projet_description'),
    path('tache/fichier/<int:fichier_tache_id>', get_fichier_tache,
         name="telecharger_fichier_tache"),

    path('diffuser/', diffuser_tache, name='diffuser_tache'),
]

web/intramwet/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('intramwet.core.urls')),
    path('admin/', admin.site.urls),
    path('django-rq/', include('django_rq.urls'))
]

# Sentry testing
if settings.DEBUG:
    def trigger_error(request):
        division_by_zero = 1 / 0

    urlpatterns += path('sentry-debug/', trigger_error),

web/apps/projet/models.py
from datetime import datetime, timezone

from django.contrib.auth import get_user_model
from django.contrib.auth.models import Permission
from django.contrib.contenttypes.models import ContentType
from django.db import models
from django.db.models.signals import post_save, pre_delete
from django.dispatch import receiver
from django.utils.functional import cached_property

from apps.materiel.models import EmpruntMateriel


class TypeProjetManager(models.Manager):
    def accessibles(self, utilisateur: get_user_model()):
        return self.all() if utilisateur.is_staff else [t for t in self.all()
                                                        if
                                                        utilisateur.has_perm(
                                                            t.full_permission_name)]


class TypeProjet(models.Model):
    typeProjet = models.CharField(max_length=200)
    objects = TypeProjetManager()

    @property
    def permission_name(self):
        return "voir_type_projet_{}".format(self.id)

    @cached_property
    def full_permission_name(self):
        return "projet.{}".format(self.permission_name)

    def create_permission(self):
        content_type = ContentType.objects.get_for_model(TypeProjet)
        Permission.objects.create(
            codename=self.permission_name,
            name='Peut accéder aux projets du type {}'.format(self.id),
            content_type=content_type,
        )

    def get_permission(self):
        content_type = ContentType.objects.get_for_model(TypeProjet)
        return Permission.objects.get(
            codename=self.permission_name,
            content_type=content_type,
        )

    def delete_permission(self):
        content_type = ContentType.objects.get_for_model(TypeProjet)
        Permission.objects.get(codename=self.permission_name,
                               content_type=content_type).delete()

    def __str__(self):
        return self.typeProjet


@receiver(post_save, sender=TypeProjet)
def init_permission_on_type_projet_created(sender, instance: TypeProjet,
                                           created: bool, **kwargs):
    if created:
        instance.create_permission()


@receiver(pre_delete, sender=TypeProjet)
def delete_permission_on_type_projet_deleted(sender, instance: TypeProjet,
                                             **kwargs):
    instance.delete_permission()


class TypeParticipantProjet(models.Model):
    typeParticipant = models.CharField("Type de participant", max_length=200)

    def __str__(self):
        return self.typeParticipant


class ProjetManager(models.Manager):
    def accessibles(self, utilisateur: get_user_model()):
        return self.all().filter(
            type__in=TypeProjet.objects.accessibles(utilisateur))


class Projet(models.Model):
    nom = models.CharField(max_length=200)
    type = models.ForeignKey(TypeProjet, on_delete=models.PROTECT)
    deadlineRendu = models.DateTimeField("Deadline de rendu", null=True,
                                         blank=True)
    description = models.TextField(null=True, blank=True)
    objects = ProjetManager()

    VALIDE = "VAL"
    EN_ATTENTE = "ATT"
    FINI = "FIN"
    statut = models.CharField(
        max_length=20,
        choices=[
            (VALIDE, "Validé"),
            (EN_ATTENTE, "En attente"),
            (FINI, "Fini"),
        ],
        default=EN_ATTENTE,
    )

    def est_admin(self, user):
        return ParticipantProjet.objects.filter(projet=self, utilisateur=user,
                                                admin=True).exists() \
               or user.is_staff

    def __str__(self):
        return "%s | %s" % (self.type, self.nom)


class ParticipantProjet(models.Model):
    projet = models.ForeignKey(Projet, on_delete=models.CASCADE,
                               related_name="participants")
    utilisateur = models.ForeignKey(get_user_model(), on_delete=models.PROTECT)
    typeParticipant = models.ManyToManyField(TypeParticipantProjet)
    admin = models.BooleanField("Administrateur de la tâche", default=False)
    numeroDeFicheCession = models.IntegerField(
        "Numero de fiche de cession de droits", null=True, blank=True)

    def __str__(self):
        return "%s | %s" % (self.projet, self.utilisateur)


class Tache(models.Model):
    projet = models.ForeignKey(Projet, on_delete=models.CASCADE,
                               related_name='taches')
    nom = models.CharField("Nom de la tache", max_length=200)
    tacheTerminee = models.BooleanField("Tache réalisée", default=False)
    description = models.TextField(null=True, blank=True)
    visible = models.BooleanField("Visible par les membres", default=False)
    membreAssigne = models.ManyToManyField(ParticipantProjet, blank=True)
    maxMembreAssignable = models.IntegerField(
        "Nombre de membre(s) maximal assignable", default=0)

    emprunts = models.ManyToManyField(EmpruntMateriel, blank=True)

    ficheCessionDroits = models.BooleanField(
        "Faire générer une fiche de cession de droits aux membres inscrits",
        default=False)

    notifPourInscription = models.BooleanField(
        "Notifier les membres si personne n'est inscrit", default=True)
    notifBureauTermine = models.BooleanField(
        "Notifier le bureau si la tâche est terminée", default=True)

    # Si la tâche possède un créneau
    notifBureauAvantDate = models.BooleanField(
        "Notifier le bureau si personne n'est inscrit avant la date",
        default=True)
    notifMembreAvantDate = models.BooleanField(
        "Notifier le membre inscrit juste avant la date", default=True)
    notifMembreApresDate = models.BooleanField(
        "Notifier le membre inscrit après la date pour avoir confirmation de la réalisation de la tâche",
        default=True)

    # Si la tâche ne possède pas de créneau
    notifBureau = models.BooleanField("Notifier périodiquement le bureau",
                                      default=True)
    notifMembre = models.BooleanField(
        "Notifier périodiquement le membre inscrit", default=True)

    diffusee = models.BooleanField("A été diffusée massivement aux membres",
                                   default=False)

    def necessite_cession_droits(self, user):
        return not FichierTache.objects.filter(utilisateur=user,
                                               tache__projet=self.projet).exists()

    def est_inscrit(self, user):
        return self.projet.est_admin(user) \
               or Creneau.objects.filter(tache=self,
                                         membreAssigne__utilisateur=user).exists() \
               or self.membreAssigne.filter(utilisateur=user).exists()

    def est_notifiable_pour_inscription(self):
        notifiable = False
        if len(self.membreAssigne.all()) < self.maxMembreAssignable:
            notifiable = True
        for creneau in self.creneaux.all():
            if creneau.est_notifiable_pour_inscription():
                notifiable = True
        return notifiable

    def __str__(self):
        return "%s | %s " % (self.projet, self.nom)


class Creneau(models.Model):
    tache = models.ForeignKey(Tache, on_delete=models.CASCADE,
                              related_name='creneaux')
    debut = models.DateTimeField("Date de début")
    fin = models.DateTimeField("Date de fin", null=True, blank=True)

    membreAssigne = models.ManyToManyField(ParticipantProjet, blank=True)
    maxMembreAssignable = models.IntegerField(
        "Nombre de membre(s) maximal assignable", default=0)

    def est_notifiable_pour_inscription(self):
        return not self.tache.tacheTerminee \
               and self.tache.projet.statut == Projet.VALIDE \
               and self.tache.visible \
               and len(self.membreAssigne.all()) < self.maxMembreAssignable \
               and datetime.now(timezone.utc) < self.debut

    def __str__(self):
        return "%s | %s" % (self.tache, self.debut)


# TODO gérer réinitialisation en fin d'année
class FichierTache(models.Model):
    tache = models.ForeignKey(Tache, on_delete=models.PROTECT,
                              related_name='fichiers')
    fichier = models.FileField(upload_to='fiches_cession_droits/')

    utilisateur = models.ForeignKey(get_user_model(), on_delete=models.PROTECT,
                                    null=True, blank=True)

    @cached_property
    def filename(self):
        return "CD_{}_{}.pdf".format(self.tache.projet.nom,
                                     self.utilisateur.nomComplet).replace(' ',
                                                                          '_').replace(
            "'",
            '_').replace(
            'é', 'e').replace('è', 'e').replace('ê', 'e') \
            .replace('à', 'a').replace('ù', 'u').replace('"', '_').replace('(',
                                                                           '_').replace(
            ')', '_') \
            .replace('[', '_').replace(']', '_').replace('{', '_').replace('}',
                                                                           '_').replace(
            '\\', '')

    def __str__(self):
        return self.filename


class PreconfigurationTache(models.Model):
    nom = models.CharField("Nom de la préconfiguration", max_length=200)
    nomTache = models.CharField("Nom de la tache", max_length=200, null=True,
                                blank=True)
    visible = models.BooleanField("Visible par les membres", default=False)
    maxMembreAssignable = models.IntegerField(
        "Nombre de membre(s) maximal assignable", default=0)
    ficheCessionDroits = models.BooleanField(
        "Faire générer une fiche de cession de droits aux membres inscrits",
        default=False)

    notifPourInscription = models.BooleanField(
        "Notifier les membres si personne n'est inscrit", default=True)
    notifBureauTermine = models.BooleanField(

web/apps/projet/templates/edit_creneau.html
{% extends "base_navbar.html" %}
{% load static %}

{% block navbar_projets %}
    active
{% endblock %}

{% block title %}
    {% if edit %}
        Modifier un créneau
    {% else %}
        Créer une créneau
    {% endif %}
{% endblock %}

{% block head_css %}
    <link href="{% static 'projet/css/projet.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block content %}
    <div class="container">
        <div class="main">
            <h2>
                {% if edit %}Modifier{% else %}Créer{% endif %} un créneau
            </h2>
            <p>
                {% if edit %}
                    Vous souhaitez modifier votre créneau ?
                {% else %}
                    Ici, vous pouvez créer votre propre créneau !
                {% endif %}
            </p>

            <form method="post" action="
                    {% if edit %}{% url 'edit_creneau' id_creneau %}{% else %}{% url 'ajout_creneau' id_tache %}{% endif %}">
                {% csrf_token %}

                {% if form.non_field_errors %}
                    <div class="alert alert-danger" role="alert">
                        <ul>
                            {% for error in form.non_field_errors %}
                                <li>{{ error }}</li>
                            {% endfor %}
                        </ul>
                    </div>
                {% endif %}

                {% for field in form.visible_fields %}
                    <div class="form-group row">
                        <div class="col-12">
                            {{ field.label_tag }}

                            {% if field.errors %}
                                <ul>
                                    {% for error in field.errors %}
                                        <li>{{ error }}</li>
                                    {% endfor %}
                                </ul>
                            {% endif %}

                            {{ field }}
                            {% if field.help_text %}
                                <small class="form-text text-muted">{{ field.help_text }}</small>
                            {% endif %}

                        </div>
                    </div>
                {% endfor %}
                <input type="submit" class="btn btn-primary form-control" value="Valider"/>
            </form>
        </div>
    </div>
{% endblock %}

{% block footer_javascript %}
    {# Date time picker #}
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
    <script type="text/javascript"
            src="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/js/tempusdominus-bootstrap-4.min.js"></script>
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/css/tempusdominus-bootstrap-4.min.css"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/locale/fr.js"></script>

    <script type="text/javascript">
        $(function () {
            picker_debut = $('#id_debut');
            picker_debut.datetimepicker({
                locale: 'fr',
                format: 'DD/MM/YYYY HH:mm',
                date: null
            });

            picker_fin = $('#id_fin');
            picker_fin.datetimepicker({
                locale: 'fr',
                format: 'DD/MM/YYYY HH:mm',
                date: null
            });

            {% if edit %}
                picker_debut.datetimepicker('date', '{{ form.debut.value|date:'d/m/Y H:i' }}');
                picker_fin.datetimepicker('date', '{{ form.fin.value|date:'d/m/Y H:i' }}');
            {% endif %}
        });
    </script>
{% endblock %}

web/apps/projet/templates/edit_tache.html
{% extends "base_navbar.html" %}
{% load static %}

{% block navbar_projets %}
    active
{% endblock %}

{% block title %}
    {% if edit %}
        Modifier une tâche
    {% else %}
        Créer une tâche
    {% endif %}
{% endblock %}

{% block head_css %}
    <link href="{% static 'projet/css/projet.css' %}" rel="stylesheet" media="screen">
{% endblock %}

{% block content %}
    <header>
        <h1>
            {% if edit %}Modifier{% else %}Créer{% endif %} une tâche
        </h1>
        <div class="header-content">
            <p>
                {% if edit %}
                    Vous souhaitez modifier votre tâche {{ form.nom.value }} ?
                {% else %}
                    Ici, vous pouvez créer votre propre tâche !
                {% endif %}
                Choisissez une préconfiguration pour paramétrer le système de notifications.
                {% if user.is_staff %}
                    Pour rajouter une préconfiguration, consultez le wiki.
                {% endif %}
            </p>
        </div>
    </header>

    <div class="container-fluid">
        <section>
            <h2 class="title">Préconfiguration</h2>

            <div class="form-group">
                <label for="#preconfiguration">Choisissez une préconfiguration :</label>
                <select required class="form-control"
                        name="preconfiguration" id="preconfiguration">
                    <option value="" active>---------</option>
                    {% for preconfig in preconfigurations %}
                        <option value="{{ forloop.counter }}"
                                {% if preconfig.nomTache %}data-nom="{{ preconfig.nomTache }}"{% endif %}
                                data-visible="{{ preconfig.visible }}"
                                data-max-membre-assignable="{{ preconfig.maxMembreAssignable }}"
                                data-fiche-cession-droits="{{ preconfig.ficheCessionDroits }}"
                                data-notif-pour-inscription="{{ preconfig.notifPourInscription }}"
                                data-notif-bureau-termine="{{ preconfig.notifBureauTermine }}"
                                data-notif-bureau-avant-date="{{ preconfig.notifBureauAvantDate }}"
                                data-notif-membre-avant-date="{{ preconfig.notifMembreAvantDate }}"
                                data-notif-membre-apres-date="{{ preconfig.notifMembreApresDate }}"
                                data-notif-bureau="{{ preconfig.notifBureau }}"
                                data-notif-membre="{{ preconfig.notifMembre }}">{{ preconfig }}</option>
                    {% endfor %}
                </select>
            </div>
        </section>

        <section>
            <h2 class="title">Options</h2>
            <form method="post" action="
                    {% if edit %}{% url 'edit_tache' id_tache %}{% else %}{% url 'ajout_tache' id_projet %}{% endif %}">
                {% csrf_token %}

                {% if form.non_field_errors %}
                    <div class="alert alert-danger" role="alert">
                        <ul>
                            {% for error in form.non_field_errors %}
                                <li>{{ error }}</li>
                            {% endfor %}
                        </ul>
                    </div>
                {% endif %}

                {% for field in form.visible_fields %}
                    {% ifequal field.field.widget.input_type 'checkbox' %}
                        <div class="form-check">
                            {{ field }}
                            <label for="{{ field.id_for_label }}" class="form-check-label">{{ field.label }}</label>
                            {% if field.help_text %}
                                <small class="form-text text-muted">{{ field.help_text }}</small>
                            {% endif %}
                        </div>
                    {% else %}

                        <div class="form-group row">
                            <div class="col-12">
                                {{ field.label_tag }}

                                {% if field.errors %}
                                    <ul>
                                        {% for error in field.errors %}
                                            <li>{{ error }}</li>
                                        {% endfor %}
                                    </ul>
                                {% endif %}

                                {{ field }}
                                {% if field.help_text %}
                                    <small class="form-text text-muted">{{ field.help_text }}</small>
                                {% endif %}

                            </div>
                        </div>
                    {% endifequal %}
                {% endfor %}
                <input type="submit" class="btn btn-primary form-control" value="Valider"/>
            </form>
        </section>
    </div>
{% endblock %}

{% block footer_javascript %}
    {# Date time picker #}
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
    <script type="text/javascript"
            src="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/js/tempusdominus-bootstrap-4.min.js"></script>
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/css/tempusdominus-bootstrap-4.min.css"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/locale/fr.js"></script>

    <script type="text/javascript">
        $(function () {
            picker_debut = $('#id_debut');
            picker_debut.datetimepicker({
                locale: 'fr',
                format: 'DD/MM/YYYY HH:mm',
                date: null
            });

            picker_fin = $('#id_fin');
            picker_fin.datetimepicker({
                locale: 'fr',
                format: 'DD/MM/YYYY HH:mm',
                date: null
            });

            {% if edit %}
                picker_debut.datetimepicker('date', '{{ form.debut.value|date:'d/m/Y H:i' }}');
                picker_fin.datetimepicker('date', '{{ form.fin.value|date:'d/m/Y H:i' }}');
            {% endif %}

            let preconfig = $('#preconfiguration');
            preconfig.change(function () {
                let data = $('#preconfiguration option[value="' + preconfig.val() + '"]').data();
                $.each(data, function (key, value) {
                    let input = $('#id_' + key);
                    if (input.prop('type') === 'checkbox') {
                        value = value === "True" ? true : (value === "False" ? false : value);
                        input.prop('checked', value);
                    } else {
                        input.val(value);
                    }
                });
            });
        });
    </script>
{% endblock %}

web/apps/projet/templates/edit_type_projet.html
<div class="modal-header">
    <h5 class="modal-title" id="modificationCategorieModalLabel">Modification de catégorie</h5>
    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
        <span aria-hidden="true">&times;</span>
    </button>
</div>

<div class="modal-body">
    <form id="modification-categorie">
        {{ form }}
    </form>
</div>

<div class="modal-footer">
    <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
    <button type="button" class="btn btn-primary" onclick="modifier()">Modifer</button>
</div>

<script type="text/javascript">
    function modifier() {
        $('#modification-categorie').ajaxSubmit({
            type: 'post',
            url: '{% url 'modification_type_projet' id %}',
            data: {
                'csrfmiddlewaretoken': '{{ csrf_token }}'
            },
            success: function (data) {
                if (data['success']) {
                    $('.modal-body').html('<p>Modification de type de projet réussie !</p>');
                    setTimeout(() => {
                        location.reload();
                    }, 500);
                } else {
                    alert("Erreur : Merci de recommencer la procédure !");
                    location.reload();
                }
            }
        });
    }
</script>

web/apps/projet/templates/manage_type_projet.html
{% extends "base_navbar.html" %}
{% load i18n widget_tweaks %}

{% block head_css %}
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/simplemde/latest/simplemde.min.css">
{% endblock head_css %}

{% block header %}
    <header>
        <h1>Gestion des types de projet</h1>
    </header>
{% endblock %}

{% block footer_javascript %}
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-confirmation2@4.0.0/dist/bootstrap-confirmation.min.js"></script>
    <script type="application/javascript">
        $('[data-toggle=confirmation]').confirmation({
            rootSelector: '[data-toggle=confirmation]'
        });
        $(document).ready(function () {
            $('#modal').on('show.bs.modal', function (event) {
                let button = $(event.relatedTarget);
                let id = parseInt(button.attr('id'));
                let url = '{% url 'modification_type_projet' 42 %}';
                url = url.replace('42', id);
                $.ajax({
                    url: url,
                    dataType: 'html',
                    success: function (data) {
                        $('#modal .modal-content').html(data);
                    }
                });
            });
        });
    </script>
{% endblock %}

{% block content %}
    <!-- Modal -->
    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <p>
                    Chargement ...
                </p>
            </div>
        </div>
    </div>

    <div class="container">
        <div class="main">
            <form method="POST" action="{% url 'gestion_types_projet' %}">
                {% csrf_token %}

                {% for field in form.visible_fields %}
                    <div class="form-group">
                        <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                        {{ field|add_class:'form-control' }}
                        {% for error in field.errors %}
                            <span class="help-block">{{ error }}</span>
                        {% endfor %}
                    </div>
                {% endfor %}

                <div class="form-group">
                    <input type="submit" value="Ajouter"
                           class="btn btn-primary btn-block"/>
                    <input type="hidden" name="next" value="{{ next }}"/>
                </div>
            </form>

            <hr>

            {% for type in types_projet %}
                <div class="card card-lg">
                    <div class="row">
                        <div class="col-md-9">
                            <h3>{{ type.typeProjet }}</h3>
                        </div>
                        <div class="col-md-1">
                            <button class="btn btn-outline-dark" data-toggle="modal" data-target="#modal"
                                    id="{{ type.id }}">
                                Modifier
                            </button>
                        </div>
                        <div class="col-md-1">
                            <a class="btn btn-danger delete" data-toggle="confirmation"
                               data-btn-ok-label="Oui!"
                               data-btn-cancel-label="Non" data-btn-cancel-class="btn-danger"
                               data-title="Êtes vous certains?"
                               style="color:white;"
                               href="{% url 'suppression_type_projet' type.id %}">
                                Supprimer
                            </a>
                        </div>
                    </div>
                </div>
            {% endfor %}
        </div>
    </div>
{% endblock %}

web/apps/projet/templates/modal_cession_droits.html
<div id="myModal" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
    <div class="modal-dialog">

        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Cession des droits d'auteur</h4>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <p>
                    La participation à cette tâche requiert une création artistique de votre part.
                    Néanmoins, il vous est nécessaire de céder les droits de cette création à l'association.
                    Ces droits nous permettent de conserver la vidéo dans nos archives, ainsi que de la distribuer
                    librement auprès de nombreux intéressés.
                    Pour plus d'informations, contactez : <a
                        href="mailto:{{ CONTACT_EMAIL }}?Subject=Cession de droits d'auteur"
                        target="_top" style="color:#007bff !important;">{{ CONTACT_EMAIL }}</a>
                </p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-primary" data-dismiss="modal">J'accepte de céder mes droits
                    d'auteur à {{ NAME }}
                </button>
            </div>
        </div>

    </div>
</div>